<%@include file="/libs/wcm/global.jsp"%>
<%@page contentType="text/html;charset=UTF-8"%>
<%@page import="com.day.cq.widget.HtmlLibraryManager"%>
<%@page import="com.day.cq.search.*, com.day.cq.search.result.*, com.day.cq.search.facets.*, com.day.cq.search.facets.buckets.*, java.util.*, javax.jcr.*, com.headwire.cq.reporting.services.*"%>
<%@page import="com.headwire.cloudwords.services.*,com.headwire.cloudwords.util.CloudwordsUtil, com.cloudwords.api.client.resources.*" %>
<%@ taglib prefix="hwcw" uri="http://cloudwords.headwire.com/taglibs/cloudwords-taglib" %>

<html>
<head>
<title>Cloudwords Projects</title>
<script src="/libs/cq/ui/resources/cq-ui.js" type="text/javascript"></script>

    <%
    HtmlLibraryManager htmlMgr = sling.getService(HtmlLibraryManager.class);
    if (htmlMgr != null) {
        htmlMgr.writeIncludes(slingRequest, out, "cq.widgets", "apps.cloudwords");
    }
    

    CloudwordsService service = CloudwordsUtil.getCloudwordsService().getService();
    String idStr = properties.get("projectId",request.getParameter("id")); 
    //request.getParameter("id");
    int id = Integer.parseInt(idStr);
    
    
    Project project = service.getProject(id);
    %><hwcw:addPath id="<%= ""+id %>" /><hwcw:getPaths id="<%= ""+id %>" /><%
	
    String[] paths = (String[])pageContext.getAttribute("pathList");
    String baseLanguage = "/"+project.getSourceLanguage().getLanguageCode()+"/";
    baseLanguage = "/en/";
    
%>
</head>
<body>
	<h2>Cloudwords Project Page</h2>
	<p>
	<a href="/etc/cloudwords/projects.html">See all projects</a>
	</p>

	<div>
	<p>
	<table>
	<tr>
	<td>Name</td>
	<td>Status</td>
	</tr>
	<%
	//CloudwordsCustomerClient client = new CloudwordsCustomerClient("https://api-stage.cloudwords.com", 1, "2986254e439f7fb5d47bdac1e8487aff2d5a5ec20c4b5e8483ed1b9300b6bc0d");
	//List<Project> projects = client.getOpenProjects();
	
		%><tr><%
		
		out.println("<td>"+project.getName()+"</td>");
		out.println("<td>"+project.getStatus().getDisplay()+"</td>");
		//out.println("<td>"+project.getBidDueDate()+"</td>");
		//out.println("<td>"+project.getDeliveryDueDate()+"</td>");
		%><td><% 
		for(Language l : project.getTargetLanguages()) {
			%><%= l.getDisplay() %>, <%
		}
		%></td><%
//		out.println("<td>"+project.getReviewDueDate()+"</td>");
	//	out.println("<td><a href='?preview&pid="+project.getId()+"'>preview content</a></td>");
	//	out.println("<td><a href='?update&pid="+project.getId()+"'>update content</a></td>");
		out.println("<td><a href='/etc/cloudwords/sendProject.html?id="+project.getId()+"'>Upload Source</a></td>");
		%></tr><%
	
	//https://app-stage.cloudwords.com/cust.htm#project/5505
	%>
	
	</table>
	</p>
	<ul><% for(Language lang : project.getTargetLanguages()) { %>
		<li><a href="/etc/cloudwords/project.update.html?id=<%= id %><%
		%>&target=<%= lang.getLanguageCode() %>">Import <%= lang.getDisplay() %> translation.</a></li>
	<% } %></ul>
	</div>	
	
	<div>
		<h3>Configured Paths</h3>
		<ul>
			<% for(String path : paths) { %><li><%= path %></li><% } %>
		</ul>
	</div>
	<div>
		<div id="addPathButton"><h3>Add a path</h3></div>
		<div id="addPathForm">
			<form method="get">
				<input type="text" size="50" name="addPath" />
				<input type="hidden" name="id" value="<%= id %>" />
				<input type="Submit" value="Add Path" />
			</form>
		</div>
	</div>
	<div>
		<h3>Naming Behavior</h3>
		<ul><% for(Language lang : project.getTargetLanguages()) { 
		%>
			<li><b><%= lang.getDisplay() %></b>, <%= baseLanguage %> will be replaced with /<%= lang.getLanguageCode() %>/</li>
		<% } %></ul>
	</div>
	
	<div>
	
	</div>
	
</body>
</html>