<%@include file="/libs/wcm/global.jsp"%>
<%@page contentType="text/html;charset=UTF-8"%>
<%@page import="com.day.cq.widget.HtmlLibraryManager,com.headwire.cloudwords.services.*,com.headwire.cloudwords.util.*"%>
<%@page import="com.day.cq.search.*, com.day.cq.search.result.*, com.day.cq.search.facets.*, com.day.cq.search.facets.buckets.*, java.util.*, javax.jcr.*, com.headwire.cq.reporting.services.*"%>
<%@page import="com.cloudwords.api.client.CloudwordsCustomerClient, com.cloudwords.api.client.resources.*" %>


<html>
<head>
<title>Demo Translation Test Results</title>
<script src="/libs/cq/ui/resources/cq-ui.js" type="text/javascript"></script>
</head>
	<body>
		<h1>Demo Translation Test Results</h1>
		<br>

    <%
    HtmlLibraryManager htmlMgr = sling.getService(HtmlLibraryManager.class);
    if (htmlMgr != null) {
        htmlMgr.writeIncludes(slingRequest, out, "cq.widgets");
    }
    
    CloudwordsManager manager = CloudwordsUtil.getService();
    
    // Test Parameters: 
    String cloudwordsProjectID = (String) request.getParameter("id");
    String msClientID = manager.getClientID(); 
    //int charCount = manager.getCharCount(); 
    String sourceLang = manager.getDefaultSourceLanguage(); 
    //String targetLang = manager.getTargetLang(); 
    //String sourceText = manager.getSourceText(); 
    //String translatedText = manager.getTranslatedText(); 
        
    CloudwordsService service = CloudwordsUtil.getService().getCloudwordsService();
	List<Language> sourceLangs = service.getSourceLanguages();
	if(sourceLangs == null) {
		sourceLangs = new ArrayList<Language>();
	}
	List<Language> targetLangs = service.getTargetLanguages();
	if(targetLangs == null) {
		targetLangs = new ArrayList<Language>();
	}
        
    %><%
    
    String[] args = new String[1];
    args[0] = ""+cloudwordsProjectID;
    
    if(cloudwordsProjectID.length()>0){
    	try {
	    	FakeVendor.main(args);
	    } catch(Exception e) {
	    	e.printStackTrace();
	    }
    %>
    	<h2>Test Parameters</h2>
		<br>
		<p>
			<ul>
				<li>Cloudwords Project ID: <%=cloudwordsProjectID%></li>
				<li>MS Client ID: <%=msClientID%></li>
				<li>Characters Translated: <%--=charCount--%></li>
				<%--  <li>Source Language: <%=getLangDisplay(sourceLangs, sourceLang)%> ---Translated To---> Target Language(s): <%=getLangDisplay(targetLangs, targetLang)%> </li>
				<li>Source Text: <%=sourceText %></li>
				<li>Translated Text: <%=translatedText %></li>
				<li></li> --%>
			</ul>
		</p>
		<!--  
		<div style="float:left;">
			<p>
				<h2>Source Pages</h2>
					<ul>
						<li></li>
					</ul>
			</p>
		</div>
		<div style="float:left;">
			<p>
				<h2>Translated Pages</h2>
					<ul>
						<li></li>
					</ul>
			</p>
		</div>
		-->
		<%
    }
    
    else{
    	
    	%>
    	<h2>Cloudwords Project ID is null, please enter a valid Project ID</h2>
    	<%
    }  
	%>
		
	</body>
</html>

<%!

String getLangDisplay(List<Language> langs, String langCode){
	
	String displayName = "Display name not found"; 
	
	if(langs!=null){
		
		for(Language lang : langs) {
			
			if(lang.getLanguageCode().equals(langCode)){
				displayName = lang.getDisplay(); 
				return displayName; 
			}
		}
	}
	
	return displayName; 
}
%>