<%@page contentType="text/html;charset=UTF-8"%><%
%><%@page import="com.day.cq.widget.HtmlLibraryManager,com.headwire.cloudwords.services.*,com.headwire.cloudwords.util.*"%><%
%><%@page import="com.day.cq.wcm.api.*,
                  com.adobe.granite.workflow.*,
                  com.adobe.granite.workflow.metadata.*,
                  com.adobe.granite.workflow.exec.*,
                  com.adobe.granite.workflow.model.*,
                  com.headwire.cloudwords.workflows.*,
                  com.headwire.cloudwords.util.*,
                  org.apache.sling.api.resource.*,
                  com.day.cq.search.facets.*,
                  com.day.cq.search.facets.buckets.*,
                  java.util.*,
                  javax.jcr.*,
                  com.headwire.cq.reporting.services.*
                  "%><%
%><%@page import="com.cloudwords.api.client.CloudwordsCustomerClient, com.cloudwords.api.client.resources.*" %><%
%><%@include file="/libs/foundation/global.jsp" %><%

	// pull all the stuff out of the session

String projectName = (String) request.getSession().getAttribute("name");
String basePath = (String) request.getSession().getAttribute("basePath");
String sourceLang = (String) request.getSession().getAttribute("sourceLang");

List<String> sourcePathsList = (List<String>) request.getSession().getAttribute("sourcePaths");
String[] sourcePaths = sourcePathsList.toArray(new String[0]);
Map<String,List<String>> targetPaths = (Map<String,List<String>>) request.getSession().getAttribute("targetPaths");



if(projectName == null ) {
	%>Project Name must be specifieid!<%
	return;
}
if(basePath == null ) {
	%><h2>Base Path must be specifieid!</h2><%
	return;
}
if(sourceLang == null ) {
	%><h2>Source Language must be specifieid!</h2><%
	return;
}
if(sourcePaths == null ) {
	%><h2>Source Paths must be specifieid!</h2><%
	return;
}
if(targetPaths == null ) {
	%><h2>Target Paths must be specifieid!</h2><%
	
	return;
}
for( String sourcePath: sourcePaths ) {
    if( sourcePath == null ) {
	    %><h2>Source Path must be specifieid!</h2><%
	    return;
    }
    if( !"/".equals( basePath ) && !sourcePath.startsWith( basePath ) ) {
	    %><h2>Base Path: <%= basePath %> is specified but Source Path: <%= sourcePath %> does not start with it</h2><%
	    return;
    }
    if( !"/".equals( basePath ) ) {
        // Target Paths must end or not end with a slash like the Base Path. Instead of reporting an error
        // we just fix this here
        for( String lang : targetPaths.keySet() ) {
            List<String> lTargetPaths = targetPaths.get( lang );
            for( int i = 0; i < lTargetPaths.size(); i++ ) {
                String lTargetPath = lTargetPaths.get( i );
                if( basePath.endsWith( "/" ) ) {
                    if( !lTargetPath.endsWith( "/" ) ) {
                        lTargetPath += "/";
                        lTargetPaths.set( i, lTargetPath );
                    }
                } else {
                    if( lTargetPath.endsWith( "/" ) ) {
                        lTargetPath = lTargetPath.substring( 0, lTargetPath.length() - 1 );
                        lTargetPaths.set( i, lTargetPath );
                    }
                }
            }
        }
    }
}

List<String> targetLanguagesList = CloudwordsUtil.getTargetLanguages(targetPaths);

String[] targetLanguages = targetLanguagesList.toArray(new String[0]);

// get workflow path
String targetModelPath = CloudwordsUtil.getWorkflowModel();
WorkflowSession session = CloudwordsUtil.getWorkflowSession(resource);

// create project page
CloudwordsProject cwProject = CloudwordsUtil.makeNewProjectPage(resourceResolver,projectName);
String targetPath = cwProject.getPagePath();

try {
	WorkflowModel model = session.getModel(targetModelPath);
	WorkflowData data = session.newWorkflowData( "JCR_PATH", targetPath );


	// put values in meta data map
	MetaDataMap metaDataMap = data.getMetaDataMap();
    String lPropertyPrefix = CloudwordsUtil.getWorkflowPropertyPrefix();

	metaDataMap.put( lPropertyPrefix + "projectPath", targetPath );

    // Properties are now stored on the Cloudwords Project Page and not in the Workflow
    cwProject.setSourceLanguage( sourceLang );
    for( String sourcePath: sourcePaths ) {
    	for( String lang : targetPaths.keySet() ) {
	    	for( String lTargetPath: targetPaths.get(lang) ) {
	    	    // Target Path must be adjusted based on the Base Path and the Source Path
	    	    // This is done this way:
	    	    // 1) Take the suffix of the Source Path where the Base Path Ends
	    	    // 2) Add that suffix to the end of the Target Path
	    	    // For Example we have
	    	    // - basePath: /content/global/en
	    	    // - sourcePath: /content/global/en/home/test
	    	    // - targetPath: /content/headwire/fr
	    	    // This will create this Target Path:
	    	    // ==> targetPath: /content/headwire/fr/home/test
	    	    if( !"/".equals( basePath ) && sourcePath.startsWith( basePath ) ) {
	    	        lTargetPath += sourcePath.substring( basePath.length() );
	    	    }
	    	    cwProject.addTargetLanguageAndPath( sourcePath, lang, lTargetPath );
	    	    
	    	}
    	}
    }
	Map<String, Object> metadata = new TreeMap<String, Object>();

	Workflow wkFlow = session.startWorkflow(model, data, metadata);
	cwProject.setWorkflowId(wkFlow.getId());
	cwProject.saveProperties(resourceResolver);

} catch(Exception e) {
	throw new RuntimeException(e);
}

response.sendRedirect("/libs/cq/workflow/content/inbox.html");
%><%--
<% for (String s : sourcePaths) { %><%= s %><br/><% }
for(String s : targetLanguages) { %><%= s %><br/><% } %>  --%>