<%@page contentType="application/json;charset=UTF-8"%><%
%><%@page import="com.day.cq.widget.HtmlLibraryManager,com.headwire.cloudwords.services.*,com.headwire.cloudwords.util.*"%><%
%><%@page import="com.day.cq.search.*, com.day.cq.search.result.*, com.day.cq.search.facets.*, com.day.cq.search.facets.buckets.*, java.util.*, javax.jcr.*, com.headwire.cq.reporting.services.*"%><%
%><%@page import="com.cloudwords.api.client.CloudwordsCustomerClient, com.cloudwords.api.client.resources.*" %><%
%><%@page import="com.day.cq.wcm.msm.api.*,java.util.Locale,javax.jcr.Node,com.day.cq.workflow.metadata.*,com.headwire.cloudwords.workflows.*" %><%
%><%@include file="/libs/foundation/global.jsp" %><%

CloudwordsService client = CloudwordsUtil.getService().getCloudwordsService();

String CLOUDWORDS_CLIENT_PATH = "/cust.htm#project/";

// get cloudwords web path from API property
String cwApiUrl = client.getProperty(CloudwordsManager.CLOUDWORDS_API_PROP,"");
String cwAppUrl = "https://app.cloudwords.com";
if(cwApiUrl.contains("sandbox")) {
	// do sandbox url instead
	cwAppUrl = "https://app-sandbox.cloudwords.com";
}

String projectPath = request.getParameter("projectPath");
Resource projectResource = resourceResolver.getResource(projectPath);
Resource contentResource = resourceResolver.getResource(projectResource, "jcr:content");
Resource sourceTargetMap = resourceResolver.getResource(contentResource, "sourceTargetMap");
%><%-- <%= projectResource.getPath() %><%= contentResource.getPath() %>--%><% 
//MetaDataMap mdm = CloudwordsUtil.getMetaDataForProject(projectResource);

ValueMap projectProps = contentResource.adaptTo(ValueMap.class);
Integer cloudwordsId = projectProps.get("projectId",0);
String sourceBasePath = projectProps.get("sourceBasePath",String.class);
String baseLanguage = projectProps.get("sourceLanguage",String.class);
String projectName = projectResource.getName();
String cloudwordsName = projectProps.get("cloudwordsName",String.class);
String status = "Unknown";
//String[] targetLangs = mdm.get("targetLanguages",new String[0]);

List<Language> targetLangs = client.getTargetLanguages();
Set<String> usedLangs = new HashSet<String>();

if(cloudwordsId != 0) {
	Project cwProject = client.getProject(cloudwordsId);
	// since we can find it in cloudwords, set some values using this instead
	cloudwordsName = cwProject.getName();
	baseLanguage = cwProject.getSourceLanguage().getDisplay();
	status = cwProject.getStatus().getDisplay();
}

// escape user defined names
if(cloudwordsName != null) {
	cloudwordsName = cloudwordsName.replaceAll("'","&apos;");
}

boolean first = true;

// begin json output for project
%>{
	"cloudwordsName": "<%= cloudwordsName %>",
	"projectName": "<%= projectName %>",
	"sourceBasePath": "<%= sourceBasePath %>",
	"baseLanguage": "<%= baseLanguage %>",
	"cloudwordsId": <%= cloudwordsId %>,
	"status": "<%= status %>",
	"cloudwordsUrl": "<%= cwAppUrl + CLOUDWORDS_CLIENT_PATH + cloudwordsId %>",
	"pages": [<%

first = true;
for(Iterator<Resource> iter = resourceResolver.listChildren(sourceTargetMap); iter.hasNext();) {
	
	Resource path = iter.next();
	// get information about this page
	ValueMap pathMap = path.adaptTo(ValueMap.class);
	String sourcePath = pathMap.get("sourcePath",String.class);
	Iterator<Resource> targets = resourceResolver.listChildren(path);
	
	// get information from the actual source page content
	Resource sourcePage = resourceResolver.getResource(sourcePath);
	Resource sourcePageContent = resourceResolver.getResource(sourcePage, "jcr:content");
	ValueMap sourceProps = sourcePageContent.adaptTo(ValueMap.class); 
	
	String sourceTitle = sourceProps.get("jcr:title",sourcePage.getName());
	// escape title
	if(sourceTitle != null) {
		sourceTitle = sourceTitle.replaceAll("'","&apos;");
	}
	
	// check if we need a comma for this object
	if(first) {
		// not this time
		first = false;
	} else {
		// output a comma
		%>,<%
	}

// begin json output for pages
%>{
		"path": "<%= sourcePath %>",
		"title": "<%= sourceTitle %>",
		"targets": {<%

	boolean innerFirst = true;
	for(;targets.hasNext();) {
		Resource targetLang = targets.next();
		ValueMap targetLangMap = targetLang.adaptTo(ValueMap.class);
		String targetPath = targetLangMap.get("targetPath","");
		
		// check if we need a comma
		if(innerFirst) {
			// not this time
			innerFirst = false;
		} else {
			// output a comma
			%>,<%
		}
		
		String targetLanguageName = "";
		for(Language l : targetLangs) {
			if(l.getLanguageCode().equals(targetLang.getName())) {
				targetLanguageName = l.getDisplay();
			}
		}
		
		%>
			"<%= targetLanguageName %>": "<%= targetPath %>"<%
	}// end targets for loop
%>		}
	}<%
%><%
// back in java code
}// end sourceTargetMap children for loop

%>]
}