<%@page contentType="application/json;charset=UTF-8"%><%
%><%@page import="com.day.cq.widget.HtmlLibraryManager,com.headwire.cloudwords.services.*,com.headwire.cloudwords.util.*,com.headwire.cloudwords.workflows.*"%><%
%><%@page import="com.day.cq.wcm.api.*, org.apache.sling.api.resource.*, com.day.cq.search.facets.*, com.day.cq.search.facets.buckets.*, java.util.*, javax.jcr.*, com.headwire.cq.reporting.services.*"%><%
%><%@page import="com.cloudwords.api.client.CloudwordsCustomerClient, com.cloudwords.api.client.resources.*,com.day.cq.workflow.metadata.*" %><%
%><%@include file="/libs/foundation/global.jsp" %><%

boolean SHOW_ONLY_CONNECTOR_PROJECTS = true;

//String projectPath = request.getParameter("projectPath");
// Resource projectResource = resourceResolver.getResource(projectPath);
// MetaDataMap mdm = CloudwordsUtil.getMetaDataForProject(projectResource);
// String[] sourcePaths = mdm.get("sourcePaths",new String[0]);

// get list of projects inside the connector
Resource cwProjects = resourceResolver.getResource("/etc/cloudwords/projects");
Page cwProjectsPage = cwProjects.adaptTo(Page.class); 

CloudwordsService client = CloudwordsUtil.getService().getCloudwordsService();
List<Project> projects = client.getOpenProjects();

%>{"projects": [<% 

boolean first = true;

for(Project p : projects) {
	CodeAndDisplay status = p.getStatus();
	String cloudwordsName = p.getName();
	int id = p.getId();
	String sourceLanguage = p.getSourceLanguage().getDisplay();
	
	// check if this project is in cloudwords
	String nodeName = "";
	for(Iterator<Page> iter = cwProjectsPage.listChildren(); iter.hasNext();) {
		
		Page cwProject = iter.next();
		
		ValueMap cwProjectMap = cwProject.getContentResource().adaptTo(ValueMap.class);
		String cwProjectId = cwProjectMap.get("projectId", "");
		
		// if id matches, set the name
		if(cwProjectId.equals(""+id)) {
			nodeName = cwProject.getName();
		}
	}
	
	if(nodeName.equals("") && SHOW_ONLY_CONNECTOR_PROJECTS ) {
		continue;
	}
	
	// escape project name
	cloudwordsName = cloudwordsName.replaceAll("'","&apos;");
	
	// build target language string
	List<Language> targetLanguages = p.getTargetLanguages();
	StringBuilder targetLangs = new StringBuilder();
	boolean langsFirst = true;
	for(Language l : targetLanguages) {
		// append comma if needed
		if(langsFirst) {
			langsFirst = false;
		} else {
			targetLangs.append(", ");
		}
		// append language
		targetLangs.append(l.getDisplay());
	}

	// check if we need a comma
	if(first) {
		// not this time
		first = false;
	} else {
		// print a comma
		%>,<%
	}
	
	// begin output
	%>{
		"cloudwordsId": <%= id %>,
		"cloudwordsName": "<%= cloudwordsName %>",
		"name": "<%= nodeName %>",
		"status": "<%= status.getDisplay() %>",
		"sourceLanguage": "<%= sourceLanguage %>",
		"targetLanguages": "<%= targetLangs.toString() %>"
	}<%
}
// end project output
%>]
}