<%@include file="/libs/wcm/global.jsp"%>
<%@page contentType="text/html;charset=UTF-8"%>
<%@page import="com.day.cq.widget.HtmlLibraryManager"%>
<%@page import="com.day.cq.search.*, com.day.cq.search.result.*, com.day.cq.search.facets.*, com.day.cq.search.facets.buckets.*, java.util.*, javax.jcr.*, com.headwire.cq.reporting.services.*"%>
<%@page import="com.headwire.cloudwords.services.*,com.headwire.cloudwords.util.CloudwordsUtil, com.cloudwords.api.client.resources.*" %>
<html>
<head>
<title>Cloudwords Projects</title>
<script src="/libs/cq/ui/resources/cq-ui.js" type="text/javascript"></script>

    <%
    HtmlLibraryManager htmlMgr = sling.getService(HtmlLibraryManager.class);
    if (htmlMgr != null) {
        htmlMgr.writeIncludes(slingRequest, out, "cq.widgets");
    }
    
	CloudwordsService service = CloudwordsUtil.getService().getCloudwordsService();
	List<Language> sourceLanguages = service.getSourceLanguages();
	if(sourceLanguages == null) {
		sourceLanguages = new ArrayList<Language>();
	}
	List<Language> targetLanguages = service.getTargetLanguages();
	if(targetLanguages == null) {
		targetLanguages = new ArrayList<Language>();
	}
    %>
</head>
<body>
	<h2>Create New Project</h2>
	<p>
	Project Configuration
	</p>

	<div>
	<form method="GET" action="/etc/cloudwords/newProject.create.html">
		<p>Project Name</p>
		<input type="text" name="name" />
		<p>Source Language</p>
		<div>
			<select name="source">
				<% for(Language lang : sourceLanguages) { %>
				<option value="<%= lang.getLanguageCode() %>"><%= lang.getDisplay() %></option>
				<% } %>
			</select>
		</div>
		<% for(int i = 1; i < 3; i++) {  %>
		<p>Target Language <%= i %></p>
		<div>
			<select name="target<%= i %>">
				<% for(Language lang : targetLanguages) { %>
				<option value="<%= lang.getLanguageCode() %>"><%= lang.getDisplay() %></option>
				<% } %>
			</select>
		</div>
		<p>Content paths</p>
		<input type="text" name="target<%= i %>path1" />
		<input type="text" name="target<%= i %>path2" />
		<% } %>
		<input type="submit" />
	</form>
	</div>	
	
</body>
</html>