<%@include file="/libs/wcm/global.jsp"%>
<%@page contentType="text/html;charset=UTF-8"%>
<%@page import="com.day.cq.widget.HtmlLibraryManager,com.headwire.cloudwords.services.CloudwordsProject,com.headwire.cloudwords.services.CloudwordsProject.TargetLanguagePath"%>
<%@page import="com.headwire.cq.reporting.services.*, java.util.List"%>
<%@ taglib prefix="hwcw" uri="http://cloudwords.headwire.com/taglibs/cloudwords-taglib" %>

<%
    HtmlLibraryManager htmlMgr = sling.getService(HtmlLibraryManager.class);
    if (htmlMgr != null) {
        htmlMgr.writeIncludes(slingRequest, out, "cq.widgets");
    }

//	List<String> pathList = (List<String>) request.getSession().getAttribute("sourcePaths");
//	if(pathList == null) {
//		pathList = new ArrayList<String>();
//	}

    CloudwordsProject cloudwordsProject = new CloudwordsProject( resource.getParent() );

    String projectName = cloudwordsProject.getProjectName();
    String sourceLang = cloudwordsProject.getSourceLanguage();
    List<String> sourcePathList = cloudwordsProject.getSourcePaths();
%>
<html>
<head>
    <title>Cloudwords Project: <%= projectName %></title>
    <cq:includeClientLib categories="cq.wcm.edit"/>
    <script src="/etc/designs/cloudwords/clientlibs.js" type="text/javascript"></script>
    <%-- For debugging purposes, I'm pulling out the cloudwords-ui.js file --%>
<%--     <script src="/etc/designs/cloudwords/clientlibs/js/cloudwords-ui.js" type="text/javascript"></script> --%>
    <script src="/libs/cq/ui/resources/cq-ui.js" type="text/javascript"></script>
    <link rel="stylesheet" type="text/css" href="/etc/designs/cloudwords/clientlibs.css" />
</head>
<body>
<h1><%= projectName %></h1>
<h3>Cloudwords Project</h3>
<em><a href="/etc/cloudwords/projects.html">Back to Project list</a></em><br/>
<%-- <em>Name: <%= projectName %></em> --%>
<%-- <em>SourceLang: <%= sourceLang %></em> --%>

<div id="CQ">
<br/>
    <div id="cq-cloudwords"></div>
</div>
<br/><br/>
<%--
<h3>
    Source Translation Paths
</h3>
<table width="80%">
    <tr>
        <th>Source Path</th>
        <th>Target Language</th>
        <th>Target Path</th>
        <th>Preview?</th>
    </tr>
<%
    for( String sourcePath: sourcePathList ) {
        List<TargetLanguagePath> targetLanguagePathList = cloudwordsProject.getTargetLanguageList( sourcePath );
        boolean first = true;
        for( TargetLanguagePath targetLanguagePath: targetLanguagePathList ) {
            if( first ) {
%>
    <tr>
        <td><%= sourcePath %></td>
<%
                first = false;
            } else {
%>
        <td></td>
<%
            }
%>
        <td><%= targetLanguagePath.getLanguage() %></td>
        <td><%= targetLanguagePath.getTargetPath() %></td>
        <td><a href="<%= targetLanguagePath.getTargetPath() %>.preview.html">Preview</a></td>
    </tr>
<%
        }
    }
%>
    <tr>

    </tr>
</table>
--%>
<%--
	<ul>
	<% for(String p : pathList) { %><li><%= p %></li><% } %>
	</ul>--%>
<%--<h3>--%>
    <%--Language Page Destination Targets--%>
<%--</h3>--%>
<%--<ul>--%>
<%--<%--%>
    <%--for( String sourcePath: sourcePathList ) {--%>
        <%--for( TargetLanguagePath targetLanguagePath : cloudwordsProject.getTargetLanguageList( sourcePath ) ) {--%>
<%--%>--%>
    <%--<li>--%>
        <%--<%= targetLanguagePath.getLanguage() %>--%>
        <%--<ul><%= targetLanguagePath.getTargetPath() %></ul>--%>
    <%--</li>--%>
<%--<%--%>
        <%--}--%>
    <%--}--%>
<%--%>--%>
<%--</ul>--%>

<%--<div>--%>
    <%--<form action="/etc/cloudwords/translationselector.done.html" method="get">--%>
        <%--<input type="submit" value="Confirm" />--%>
    <%--</form>--%>
<%--</div>--%>


<script type="text/javascript">
    CQ.Ext.onReady(function() {
        var bps = new CQ.wcm.msm.CloudwordsProject({
            "renderTo": "cq-cloudwords",
            "url": "<%= currentPage.getPath() %>"
        });
    });
</script>

</body>
</html>