<%@include file="/libs/wcm/global.jsp"%>
<%@page contentType="text/html;charset=UTF-8"%>
<%@page import="com.day.cq.widget.HtmlLibraryManager,com.headwire.cloudwords.services.*,com.headwire.cloudwords.util.*"%>
<%@page import="com.day.cq.search.*, com.day.cq.search.result.*, com.day.cq.search.facets.*, com.day.cq.search.facets.buckets.*, java.util.*, javax.jcr.*, com.headwire.cq.reporting.services.*"%>
<%@page import="com.cloudwords.api.client.resources.*" %>
<html>
<head>
<title>Cloudwords Projects</title>
<script src="/libs/cq/ui/resources/cq-ui.js" type="text/javascript"></script>

    <%
    HtmlLibraryManager htmlMgr = sling.getService(HtmlLibraryManager.class);
    if (htmlMgr != null) {
        htmlMgr.writeIncludes(slingRequest, out, "cq.widgets");
    }
    
    //int projId = DemoUtil.createProject();
    //List<Resource> resources = DemoUtil.getResources(resourceResolver);
    int id = Integer.parseInt(request.getParameter("id"));
    //int bid = Integer.parseInt(request.getParameter("bid"));
    CloudwordsService service = CloudwordsUtil.getService().getCloudwordsService();
    TranslationImporter importer = CloudwordsUtil.getImporter();
    String target = request.getParameter("target");
    Project proj = service.getProject(id);
    String source = proj.getSourceLanguage().getLanguageCode();
    List<String> paths = importer.importAndUpdate(service.getTranslatedProject(id,target),resourceResolver,source,target);
    %>
</head>
<body>
	<h2>Cloudwords Projects</h2>
	<p>
	Updating project
	</p>

	<div>
	<h3>Pages</h3>
	<ul>
	<% for(String pagePath : paths) { 
			pagePath = pagePath.substring(0,pagePath.indexOf("/jcr:content"));
	%>
		<li><a href="<%= pagePath %>.html"><%= pagePath %></a></li>
	<% } %>
	</ul>
	<p><a href="/etc/cloudwords/project.html?id=<%= id %>">Go back to project</a></p>
	</div>
	
</body>
</html>