<%@include file="/libs/wcm/global.jsp"%>
<%@page contentType="text/html;charset=UTF-8"%>
<%@page import="com.day.cq.widget.HtmlLibraryManager,com.headwire.cloudwords.services.*,com.headwire.cloudwords.util.*"%>
<%@page import="com.day.cq.search.*,
                com.day.cq.search.result.*,
                com.day.cq.search.facets.*,
                com.day.cq.search.facets.buckets.*,
                java.util.*,
                javax.jcr.*,
                com.headwire.cq.reporting.services.*
                "%>
<%@page import="com.cloudwords.api.client.resources.*,org.apache.commons.lang3.StringEscapeUtils" %>
<%@ taglib prefix="hwcw" uri="http://cloudwords.headwire.com/taglibs/cloudwords-taglib" %>
<html>
<head>
<title>Cloudwords Projects</title>
<cq:includeClientLib categories="cq.wcm.edit,apps.cloudwords"/>
<%--     <script src="/etc/designs/cloudwords/clientlibs.js" type="text/javascript"></script> --%>
    <%-- For debugging purposes, I'm pulling out the cloudwords-ui.js file --%>
<%--     <script src="/etc/designs/cloudwords/clientlibs/js/cloudwords-ui.js" type="text/javascript"></script> --%>
<script src="/libs/cq/ui/resources/cq-ui.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="/etc/designs/cloudwords/clientlibs.css" />

    <%
    HtmlLibraryManager htmlMgr = sling.getService(HtmlLibraryManager.class);
    if (htmlMgr != null) {
        htmlMgr.writeIncludes(slingRequest, out, "cq.widgets");
    }
    
//	List<String> pathList = (List<String>) request.getSession().getAttribute("sourcePaths");
//	if(pathList == null) {
//		pathList = new ArrayList<String>();
//	}
	
	Map<String,List<String>> targetPaths = (Map<String,List<String>>) request.getSession().getAttribute("targetPaths");
    if(targetPaths == null) {
    	targetPaths = new HashMap<String,List<String>>();
    }
	
    String projectName = request.getParameter("name");
    String basePath = request.getParameter("basePath");
    String sourceLang = request.getParameter("sourceLang");
    
    request.getSession().setAttribute("name",projectName);
    request.getSession().setAttribute("basePath",basePath);
    request.getSession().setAttribute("sourceLang",sourceLang);
    %>
</head>
<body>
	<h3>Project Configuration</h3>
	<em>Name: <%= projectName %></em>
	<em>BasePath: <%= basePath %></em>
	<em>SourceLang: <%= sourceLang %></em>
	<h3>
	Source Translation Paths
	</h3>		
<div id="CQ">
    <div id="cq-cloudwordsconfirm"></div>
</div>
<%--  
	<ul>
	<% for(String p : pathList) { %><li><%= p %></li><% } %>
	</ul>--%>
	<h3>
	Language Page Destination Targets
	</h3>
	<ul>
	<% for(String k : targetPaths.keySet()) { %><li><%= k %>
		<ul>
			<% for(String p : targetPaths.get(k)) { %><li><%= p %></li><% } %>
		</ul>
		</li><% } %>
	</ul>
	
	<div>
	<form action="/etc/cloudwords/translationselector.done.html" method="get">
		<input type="submit" value="Confirm" />
	</form>
	</div>


<script type="text/javascript">
	CQ.Ext.Ajax.timeout = 360000;
    CQ.Ext.onReady(function() {
        var bps = new CQ.wcm.msm.CloudwordsConfirm({
            "renderTo": "cq-cloudwordsconfirm"
        });
    });
</script>
</body>
</html>